local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

local GetPowerRegen = GetPowerRegen
local math = math
local select = select

a.Rotations = {}
c.RegisterForEvents(a)
a.SetSpamFunction(function()
	a.InExecute = s.HealthPercent() < 20
	a.Rage = c.GetPower(select(2, GetPowerRegen()))
	a.Enraged = c.HasBuff("Enrage", true)
	if c.IsQueued("Bloodthirst", "Mortal Strike") then
		a.Rage = a.Rage + 10
	elseif c.IsQueued("Berserker Rage") then
		a.Rage = a.Rage + 10
		a.Enraged = true
	elseif c.IsQueued("Battle Shout", "Commanding Shout", "Charge") then
		a.Rage = a.Rage + 20
	elseif c.IsQueued("Shield Slam") then
		if s.Buff("player", c.GetID("Sword and Board")) then
			a.Rage = a.Rage + 25
		else
			a.Rage = a.Rage + 20
		end
	elseif c.IsQueued("Revenge") then
		a.Rage = a.Rage + 15
	end
	a.Rage = math.min(s.MaxPower("player"), a.Rage)
	a.EmptyRage = s.MaxPower("player") - a.Rage
	c.Flash(a)
end)

-------------------------------------------------------------------------- Arms
a.Rotations.Arms = {
	Spec = 1,
	OffSwitch = "arms_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Recklessness for Arms",
			"Avatar",
			"Bloodbath",
			"Berserker Rage for Arms",
			"Heroic Leap",
			"Impending Victory for Heals, Optional",
			"Victory Rush for Heals, Optional",
			"Enraged Regeneration",
			"Sunder Armor",
			"Pummel",
			"Disrupting Shout")
		if a.InExecute then
			c.PriorityFlash(
				"Mortal Strike",
				"Colossus Smash",
				"Execute",
				"Storm Bolt",
				"Dragon Roar",
				"Overpower",
				"Victory Rush",
				"Shockwave",
				"Heroic Throw",
				"Shout for Rage")
		else
			c.FlashAll("Deadly Calm for Dps", "Heroic Strike for Arms")
			c.PriorityFlash(
				"Mortal Strike",
				"Colossus Smash",
				"Storm Bolt",
				"Dragon Roar",
				"Overpower",
				"Impending Victory",
				"Victory Rush",
				"Shockwave",
				"Slam with Colossus Smash or High Rage",
				"Heroic Throw",
				"Shout for Rage unless Colossus Smash",
--				"Bladestorm for Arms",
				"Slam",
				"Shout for Rage")
		end
	end,
	
	FlashAlways = function()
		c.FlashAll("Dps Stance")
	end,
}

-------------------------------------------------------------------------- Fury
a.Rotations.Fury = {
	Spec = 2,
	OffSwitch = "fury_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Recklessness for Fury",
			"Avatar",
			"Bloodbath for Fury",
			"Berserker Rage for Fury",
			"Heroic Leap",
			"Impending Victory for Heals, Optional",
			"Victory Rush for Heals, Optional",
			"Enraged Regeneration",
			"Sunder Armor",
			"Pummel",
			"Disrupting Shout")
		
		if a.InExecute then
			c.PriorityFlash(
				"Bloodthirst",
				"Bloodthirst Wait",
				"Dragon Roar",
				"Colossus Smash",
				"Execute",
				"Storm Bolt",
				"Raging Blow",
				"Victory Rush",
				"Shockwave",
				"Heroic Throw",
				"Shout")
		else
			c.FlashAll("Deadly Calm for Dps", "Heroic Strike for Fury")
c.Debug("Flash", a.Rage, not not a.Enraged,
			c.PriorityFlash(
				"Bloodthirst",
				"Wild Strike before Bloodthirst",
				"Bloodthirst Wait",
				"Dragon Roar",
				"Colossus Smash",
				"Storm Bolt",
				"Raging Blow",
				"Wild Strike under Bloodsurge",
				"Impending Victory",
				"Victory Rush",
				"Shockwave",
				"Bladestorm for Fury",
				"Shout for Rage unless Colossus Smash",
				"Heroic Throw",
				"Wild Strike testing Colossus Smash",
				"Shout for Rage")
)
		end
	end,
	
	FlashAlways = function()
		c.FlashAll("Dps Stance")
	end,
}

-------------------------------------------------------------------- Protection
local uncontrolledMitigationCooldowns = {
	"Second Wind",
	"Spell Reflection",
	"Rallying Cry",
	-- demoralizing banner?
}

a.Rotations.Protection = {
	Spec = 3,
	OffSwitch = "prot_off",
	
	FlashInCombat = function()
		c.FlashMitigationBuffs(
			1,
			uncontrolledMitigationCooldowns,
			"No Mitigation if Victory Available",
			"Demoralizing Shout",
			"Enraged Regeneration for Prot",
			"Shield Wall under 3 min",
			"Last Stand",
			"Shield Wall 3+ min")
		c.FlashAll(
			"Shield Block",
			"Shield Barrier",
			"Berserker Rage for Prot",
			"Heroic Strike for free",
			"Taunt",
			"Sunder Armor",
			"Pummel",
			"Disrupting Shout")
c.Debug("Flash", a.Rage,
		c.PriorityFlash(
--			"Shockwave for Stun",
--			"Dragon's Roar for Stun",
			"Thunder Clap for Debuff",
			"Impending Victory for Heals",
			"Victory Rush for Heals",
			"Shield Slam",
			"Revenge",
			"Shout for Rage",
			"Thunder Clap for Refresh",
			"Deadly Calm Glyphed",
			"Devestate")
)
	end,
	
	FlashAlways = function()
		c.FlashAll("Defensive Stance")
	end,
}
